#!/usr/bin/python3
import math,os
import matplotlib.pyplot as plt

print('*** Risanje smernih diagramov in izračun smernosti - S53MV 4.12.2021 ***')
seznam=[x for x in os.listdir() if x.endswith(".txt")]	#seznam vhodnih zapisov .txt
print('Število zapisov .txt: '+str(len(seznam)))

steveczapis=0			#zanka po vhodnih zapisih .txt
delsmer=[]
while len(seznam)>steveczapis:
	print (str(steveczapis)+' '+seznam[steveczapis],end=' ')
	zapis=open(seznam[steveczapis],'r')
	datumura=zapis.readline()	#glava s časom meritve
	naslov=zapis.readline()[:-1]
	print(naslov,end=' ')	#naslov meritve
	i=0			#3601 vrstic podatkov: kot+jakost
	x=[]
	y=[]
	m=-1.0
	while i<=3600:
		s=zapis.readline().split()
		k,r=float(s[0]),float(s[1])
		x+=[k]
		y+=[r]
		if r>m:		#išči maksimum in kot maksimuma
			m=r
			km1=k
		if r==m:
			km2=k
		i+=1
	zapis.close()		#zapri vhodni zapis
	i=0			#normaliziraj smerni diagram na maksimum
	while i<=3600:
		y[i]=y[i]-m
		i+=1
	maxamp='%5.1f'%m+'dB'
	km=(km1+km2)*0.5	#srednji kot maksimuma s popravki
	if km2-km1>180:
		km+=180
	if km>360:
		km-=360
	odklon='%7.1f'%(km-180)+'°'
	print('Max:'+maxamp+' Odklon:'+odklon,end=' ')
	i=int(km*10+0.5)	#poišči spodnjo mejo -3dB
	j=3600
	while j>0:
		if i<0:
			i+=3600
		km1=i*0.1
		if y[i]<-3.0:
			j=0
		i-=1
		j-=1
	i=int(km*10+0.5)	#poišči gornjo mejo -3dB
	j=3600
	while j>0:
		if i>3600:
			i-=3600
		km2=i*0.1
		if y[i]<-3.0:
			j=0
		i+=1
		j-=1
	alfa=km2-km1		#preskok 360 stopinj?
	if alfa<0:
		alfa+=360
	sirina='%6.1f'%alfa+'°'
	print('Širina-3dB:'+sirina,end=' ')
	i=1			#integriraj smerni diagram
	s=0.0
	im=int(km*10+0.5)
	while i<1800:
		i1=im-i
		if i1<0:
			i1=i1+3600
		i2=im+i
		if i2>3600:
			i2=i2-3600
		ff=math.pow(10,y[i1]*0.1)+math.pow(10,y[i2]*0.1)
		s=s+ff*math.sin(math.radians(i*0.1))
		i+=1
	D=10*math.log((7200/math.pi)/s,10)	#preračunaj smernost v dBi
	smernost='%6.2f'%D+'dBi'
	print('Smernost:'+smernost)
	delsmer+=[[0,naslov,alfa,D]]	#zapiši naslov, širino in delno smernost
	fig=plt.figure()	#risanje grafa v izhodni zapis
	x1=[]			#priprava krogov
	y1=[]
	x2=[]
	y2=[]
	x3=[]
	y3=[]
	x4=[]
	y4=[]
	xx=[]			#pretvorba podatkov
	yy=[]
	i=0
	while i<=3600:
		s=math.sin(math.radians(i*0.1))
		c=math.cos(math.radians(i*0.1))
		x1=x1+[s/4]
		y1=y1+[c/4]
		x2=x2+[s/2]
		y2=y2+[c/2]
		x3=x3+[3*s/4]
		y3=y3+[3*c/4]
		x4=x4+[s]
		y4=y4+[c]
		a=(y[i]+40.0)/40.0	#logaritemsko merilo
		if a<0.0:
			a=0.0
		xx+=[a*s]
		yy+=[-a*c]
		i+=1
	l=0.2			#nariši kroge koordinatne mreže
	plt.plot(x1,y1,'g-',lw=l)	#krog polmera 0.25
	plt.plot(x2,y2,'g-',lw=l)	#krog polmera 0.5
	plt.plot(x3,y3,'g-',lw=l)	#krog polmera 0.75
	plt.plot(x4,y4,'g-',lw=l)	#krog polmera 1
	k=0			#razdelki po 30 stopinj
	while k<360:
		xk=math.sin(math.radians(k))*0.25
		yk=math.cos(math.radians(k))*0.25
		plt.plot([0.0,xk],[0.0,yk],'g-',lw=l)
		k+=30
	k=0			#razdelki po 15 stopinj
	while k<360:
		xz=math.sin(math.radians(k))*0.25
		yz=math.cos(math.radians(k))*0.25
		xk=math.sin(math.radians(k))*0.5
		yk=math.cos(math.radians(k))*0.5
		plt.plot([xz,xk],[yz,yk],'g-',lw=l)
		k+=15
	k=0			#razdelki po 5 stopinj
	while k<360:
		xz=math.sin(math.radians(k))*0.5
		yz=math.cos(math.radians(k))*0.5
		xk=math.sin(math.radians(k))
		yk=math.cos(math.radians(k))
		plt.plot([xz,xk],[yz,yk],'g-',lw=l)
		k+=5
	r=1.03			#nariši položaj maksimuma in širino lista
	plt.plot([0.0,math.sin(math.radians(km))*r],[0.0,-math.cos(math.radians(km))*r],'y-')
	plt.plot([0.0,math.sin(math.radians(km1))*r],[0.0,-math.cos(math.radians(km1))*r],'r-')
	plt.plot([0.0,math.sin(math.radians(km2))*r],[0.0,-math.cos(math.radians(km2))*r],'r-')
	plt.plot(xx,yy,'b-')	#nariši smerni diagram
	plt.axis([-1.05,1.05,-1.05,1.05])
	plt.xticks([])
	plt.yticks([])
	plt.title(datumura+naslov)
	plt.xlabel('Širina-3dB:'+sirina+'    Odklon:'+odklon+'    Smernost:'+smernost)
	plt.ylabel('Logaritemsko radialno merilo (razpon 40dB)')
	plt.gca().set_aspect('equal')
	fig.savefig(naslov+'.png', dpi=150)
	plt.close()
	steveczapis+=1		#naslednji zapis

i=0 				#določi frekvence iz naslovov
while i<len(delsmer):
	freq,naslov,alfa,D=delsmer[i]
	j=0	#določi frekvenco iz naslova
	while j<len(naslov):
		if naslov[j].isdigit():
			freq*=10
			freq+=int(naslov[j])
		j+=1
	delsmer[i][0]=freq
	i+=1
j=True				#sortiraj delne smernosti po frekvenci
while j:
	j=False
	i=0
	while i+1<len(delsmer):
		if delsmer[i+1][0]<delsmer[i][0]:
			delsmer[i],delsmer[i+1]=delsmer[i+1],delsmer[i]
			j=True
		i+=1
izhod=open('tabela','w')	#izpiši delne smernosti in skupno v izhodno tabelo
i=0
while i+1<len(delsmer):
	f1,n1,a1,D1=delsmer[i]
	f2,n2,a2,D2=delsmer[i+1]
	if f1==f2:
		s1='Rez: '+n1+' %6.2f'%a1+'°%6.2f'%D1+'dBi '
		s2='Rez: '+n2+' %6.2f'%a2+'°%6.2f'%D2+'dBi '
		if n2<n1:	#zamenjaj vrstni red rezov?
			s1,s2=s2,s1
		D=10*math.log(2/(math.pow(10,-0.1*D1)+math.pow(10,-0.1*D2)),10)
		s=s1+s2+'Skupaj:%6.2f'%D+'dBi'
		print(s)
		izhod.write(s+'\n')
	i+=1
izhod.close()			#zapri izhodni zapis
os.system('convert -delay 200 -loop 0 *.png output.gif')	#ustvari animacijo gif
os.system('rm *.txt')		#pobriši nepotrebne meritve .txt
os.system('rm *.png')		#pobriši nepotrebne risbe .png
input('*** Konec programa ***')
