#!/usr/bin/python3
import time,serial,math		#uporabljene funkcije
txime='/dev/ttyUSB2'		#ime zaporednega vmesnika oddajnika
rxime='/dev/ttyUSB1'		#ime zaporednega vmesnika sprejemnika
vrtime='/dev/ttyUSB0'		#ime zaporednega vmesnika vrtiljaka
amplituda=bytes('A10\n','utf-8')	#jakost oddajnika
modulacija=bytes('M10200\n','utf-8')	#modulacija oddajnika
meritev=bytes('5D','utf-8')	#hitrost meritve
povratek=bytes('8L','utf-8')	#hitrost povratka
cakanje=22			#čakanje na povratek vrtiljaka

print('*** Zajem smernih diagramov po seznamu frekvenc - S53MV 19.10.2021 ***')
i=input('Ime seznama frekvenc: ')
seznam=open(i,'r')
porocilo=open(i+'.log','w')

naslov=seznam.readline()[:-1]
while len(naslov)>0:
	print('Naslov meritve: '+naslov+' Počakaj na lenobni USB...')
	f='F'			#izračunaj frekvenco iz naslova
	i=0
	while i<len(naslov):
		if naslov[i].isdigit():
			f+=naslov[i]
		i+=1
	f+='000\n'		#MHz v kHz
	frekvenca=bytes(f,'utf-8')
	tx=serial.Serial(txime,9600,timeout=3.0)	#odpri tty tx 9600bps
	tx.setRTS(False)	#sprosti /BOOTLOADER
	tx.setDTR(False)	#sprosti /RESET
	time.sleep(3)
	tx.write(amplituda)	#nastavi jakost oddajnika
	time.sleep(0.2)
	tx.write(frekvenca)	#nastavi frekvenco oddajnika
	time.sleep(0.2)
	tx.write(modulacija)	#nastavi modulacijo oddajnika
	time.sleep(1)
	tx.close()		#zapri comport oddajnika
	x=[]			#polji za rezultat nove meritve
	y=[]
	i=0			#3601 vrstic podatkov: kot+jakost
	while i<=3600:
		x+=[i*0.1]
		y+=[99.99]	#99.99 za javljanje napake
		i+=1
	rx=serial.Serial(rxime,115200,timeout=3.0)	#odpri tty rx+vrt 115200bps
	rx.setRTS(False)	#sprosti /BOOTLOADER
	rx.setDTR(False)	#sprosti /RESET
	vrt=serial.Serial(vrtime,115200,timeout=3.0)
	vrt.setRTS(False)	#sprosti /BOOTLOADER
	vrt.setDTR(False)	#sprosti /RESET
	time.sleep(3)
	vrt.flushInput()	#počisti sprejemni vmesnik vrtiljaka
	vrt.write(meritev)	#meritev z vrtiljakom
	i=0			#zanka merjenja antene
	while i<3600:
		s=vrt.readline()
		k=float(s)
		rx.flushInput()
		rx.readline()
		s=rx.readline()
		r=float(s)
		print('Kot:%6.1f'%k+' Jakost:%6.2f'%r+'dB    ',end='\r')
		i=int(k*10.0+0.5)
		y[i]=r
	vrt.write (povratek)	#povratek vrtiljaka
	t=time.ctime()		#zabelezi čas meritve
	f=t[20:24]+t[4:7]+t[8:10]+t[11:13]+t[14:16]+t[17:19]+'.csv'	#ime izhodnega zapisa
	print('\nMeritev v zapis: '+f)
	iz=open(f,'w')		#shrani izmerjene podatke v izhodni zapis
	iz.write(t+'\n')	#prva vrstica: čas meritve
	iz.write(naslov+'\n')	#druga vrstica: naslov meritve
	i=0			#3601 vrstic podatkov: kot+jakost
	while i<=3600:
		iz.write('%05.1f'%(x[i])+' %05.2f'%(y[i])+'\n')
		i+=1
	iz.close()		#zapri izhodni zapis
	rx.close()		#zapri oba comporta
	vrt.close()
	m=-1			#hitri rezultati na zaslon in v poročilo, išči max
	i=0
	while i<=3600:
		if y[i]>m:
			m=y[i]
			km1=x[i]
		if y[i]==m:
			km2=x[i]
		i+=1
	i=0			#normaliziraj smerni diagram na max
	while i<=3600:
		y[i]=y[i]-m
		i+=1
	km=(km1+km2)*0.5	#srednji kot maksimuma s popravki
	if km2-km1>180:
		km+=180
	if km>360:
		km-=360
	i=int(km*10+0.5)	#poišči spodnjo mejo -3dB
	j=3600
	while j>0:
		if i<0:
			i+=3600
		km1=i*0.1
		if y[i]<-3.0:
			j=0
		i-=1
		j-=1
	i=int(km*10+0.5)	#poišči gornjo mejo -3dB
	j=3600
	while j>0:
		if i>3600:
			i-=3600
		km2=i*0.1
		if y[i]<-3.0:
			j=0
		i+=1
		j-=1
	alfa=km2-km1		#preskok 360 stopinj?
	if alfa<0:
		alfa+=360
	i=1			#integriraj smerni diagram
	s=0.0
	im=int(km*10+0.5)
	while i<1800:
		i1=im-i
		if i1<0:
			i1=i1+3600
		i2=im+i
		if i2>3600:
			i2=i2-3600
		ff=math.pow(10,(y[i1]*0.1))+math.pow(10,(y[i2]*0.1))
		s+=ff*math.sin(math.radians(i*0.1))
		i+=1
	D=(7200/math.pi)/s	#izračunaj smernost
	smernost='Max:%5.1f'%m+'dB    Odklon:%6.1f'%(km-180.0)+'°    Sirina-3dB:%6.1f'%alfa+'°    '
	smernost+='Smernost: %5.1f'%(D)+' = %5.2f'%(10*math.log(D,10))+'dBi'
	print(smernost)		#rezultati na zaslov in v poročilo
	porocilo.write(naslov+' '+smernost+'\n')
	time.sleep(cakanje)	#počakaj na povratek vrtiljaka
	naslov=seznam.readline()[:-1]

seznam.close()	#zapri seznam in poročilo
porocilo.close()
input('*** Konec programa ***')
